#include "main.h"

#ifdef USE_SOUND
Mix_Chunk *MissileExplosionSound,*BombExplosionSound,*GameoverSound,*CitySound;

#include "SDL_mixer.h"
    Mix_Music *Music[MUSICNUM];
    char text[200],ModName[MUSICNUM][20]=
	{"ramagard.s3m","icefront.s3m","autonom.s3m","pennight.mod","datajack.s3m"};
#endif
    int sound=1,CurrentMusic;

void PlayMusic()
{
#ifdef USE_SOUND
    if (!sound) return;
    
    CurrentMusic=abrand(0,MUSICNUM-1);
    if ( (!Mix_PlayingMusic()) && (sound) ) 
	Mix_PlayMusic(Music[CurrentMusic],1);
#endif
}

void SetVol()
{
#ifdef USE_SOUND
    if (!sound) return;
    
    MissileExplosionSound->volume = SoundVol*2;
//    CitySound->volume = SoundVol*4;
//    GameoverSound->volume = SoundVol*7;
    BombExplosionSound->volume = SoundVol*4;
    Mix_VolumeMusic(MusicVol*4);
#endif
}

void InitSound()
{
#ifdef USE_SOUND
    int i;

    if (!sound) return;
    if ( Mix_OpenAudio(22050, AUDIO_S16, 2, 1024) < 0 ) {
	fprintf(stderr,"Warning: Couldn't set 22025 Hz 16-bit audio\n- Reason: %s\n",SDL_GetError());
	fprintf(stderr,"\t**\nSOUND TURNED OFF\n\t**\n");
	sound=0;
    } else {
	for (i=0;i<MUSICNUM;i++) {
		#ifdef __BEOS__
		sprintf(text,"%s/sound/%s",Bdatapath,ModName[i]);
		#else
	    sprintf(text,"%s/sound/%s",DATAPATH,ModName[i]);
		#endif
	    Music[i] = Mix_LoadMUS(text);
	    if (Music==NULL) printf("COULD NOT LOAD MUSIC: %s\n", SDL_GetError());
	}
        Mix_VolumeMusic(MusicVol*7);
    #ifdef __BEOS__
    sprintf(text,"%s/sound/%s",Bdatapath,"missex.wav");
    #else
	sprintf(text,"%s/sound/%s",DATAPATH,"missex.wav");
	#endif
	MissileExplosionSound = Mix_LoadWAV(text);
	#ifdef __BEOS__
	sprintf(text,"%s/sound/%s",Bdatapath,"Wooeep.wav");
	#else
	sprintf(text,"%s/sound/%s",DATAPATH,"Wooeep.wav");
	#endif
	CitySound = Mix_LoadWAV(text);
	#ifdef __BEOS__
	sprintf(text,"%s/sound/%s",Bdatapath,"Machine.wav");
	#else
	sprintf(text,"%s/sound/%s",DATAPATH,"Machine.wav");
	#endif
	GameoverSound = Mix_LoadWAV(text);
	#ifdef __BEOS__
	sprintf(text,"%s/sound/%s",Bdatapath,"bombex.wav");
	#else
	sprintf(text,"%s/sound/%s",DATAPATH,"bombex.wav");
	#endif
	BombExplosionSound = Mix_LoadWAV(text);
	CurrentMusic = abrand(0,MUSICNUM-1);
    }
    Mix_HookMusicFinished(PlayMusic);
#endif
}

void PlaySound(Mix_Chunk *Sample)
{
#ifdef USE_SOUND
    if (sound) {
	Mix_PlayChannel(-1,Sample,0);
//	printf("Playing on channel %d\n",i);
    }
#endif
}